#NoTrayIcon
#include <FileConstants.au3>

; Name of irfanview executable in case you use other version - change here
Global $irfanexe = "i_view32.exe"

If $CmdLine[0] <> 0 Then
	;Selecting image to convert by drag-n-dropping image file on executable
	Global $Fpath = $CmdLine[1]
Else
	;Selecting image to convert through dialog window
	Global $Fpath = FileOpenDialog("Select Image", @WorkingDir, "All Files(*.*)", 1)
EndIf

;Extracting palette from image with irfanview
ShellExecuteWait(@ScriptDir & "/" & $irfanexe, " /export_pal=deleteme.pal /file=" & $Fpath & "/cmdexit")

;Reading unmodified palette from file to memory
$file = FileOpen(@WorkingDir & "/deleteme.pal", 512)
$aArrayShort = FileReadToArray($file)
FileClose($file)

;Palette rgb entries to modify, these can be changed to any indexes and values
;rgb values in palette file are shifted by +3 indexes: first entry(0) would be 3, last entry(255) would be 258
Dim $aArrayFull[260]
$aArrayFull[3] = "0 0 0"
$aArrayFull[84] = "224 224 240"
$aArrayFull[85] = "212 212 232"
$aArrayFull[86] = "204 204 224"
$aArrayFull[87] = "196 192 220"
$aArrayFull[88] = "184 184 212"
$aArrayFull[89] = "176 172 204"
$aArrayFull[90] = "164 160 196"
$aArrayFull[91] = "156 152 188"
$aArrayFull[243] = "156 148 188"
$aArrayFull[244] = "124 120 148"
$aArrayFull[245] = "92 92 108"
$aArrayFull[246] = "60 60 68"
$aArrayFull[247] = "28 28 32"
$aArrayFull[248] = "140 204 184"
$aArrayFull[249] = "104 164 152"
$aArrayFull[250] = "72 124 120"
$aArrayFull[251] = "44 80 84"
$aArrayFull[252] = "20 40 44"
$aArrayFull[255] = "252 252 164"
$aArrayFull[256] = "220 232 140"
$aArrayFull[257] = "192 212 120"
$aArrayFull[258] = "164 192 104"

;Changing the palette
$j = 0
$data = ""
For $i = 0 To 259
	If $aArrayFull[$i] <> "" Then
		$data = $data & $aArrayFull[$i] & @CRLF
	Else
		$data = $data & $aArrayShort[$j] & @CRLF
		$j = $j + 1
	EndIf
Next

;Saving the modified palette
$file = FileOpen(@WorkingDir & "/deleteme.pal", 514)
FileWrite($file, $data)
FileClose($file)

;Importing modified palette back into image with irfanview and OVERWRITING old image file
ShellExecuteWait(@ScriptDir & "/" & $irfanexe, " /import_pal=deleteme.pal /file=" & $Fpath & "/convert=" & $Fpath)

;deleting redundant palette
FileDelete(@WorkingDir & "/deleteme.pal")
